<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { cloneDeep, find } from "lodash";

@Component({})
export default class SettingSellerUpsaleComponent extends Vue {
  @Prop()
  tab!: number;

  config = {
    page: 1,
    limit: 25,
    search: "",
    status: "active",
    filter: {},
  };
  totalPage = 0;

  configDiscount = {
    page: 1,
    limit: 25,
    search: "",
    status: true,
  };

  listStore = [];
  listStoreId = [];
  listStoreSelected = [];
  listDiscount = [];
  sellerDiscountId = "";
  status = false;

  loadingTable = false;

  async mounted() {
    await this.onGetListStore();
    await this.onGetListDiscount();
    this.onGetListUpsale();
  }

  async onGetListUpsale() {
    try {
      const storeId = this.$store.state.sellerStore.storeId;
      if (!storeId) return;
      const response = await this.$api.store.listStoreUpsale(storeId);
      if (response?.data?.listStoreId?.length) {
        this.listStoreId = response.data.listStoreId.map(
          (item: any) => item._id
        );
        this.status = response.data.status;
        this.sellerDiscountId = response.data?.sellerDiscountId._id;
      }
    } catch (error) {}
  }

  async onGetListDiscount() {
    try {
      const response = await this.$api.discounts.list(
        this.storeId,
        this.configDiscount
      );
      if (response?.data?.data) {
        this.listDiscount = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  async onGetListStore() {
    try {
      const storeId = this.$store.state.sellerStore.storeId;
      this.config.filter = {
        _id: { $ne: storeId },
      };
      const response = await this.$api.store.list(this.config);
      if (response?.data) {
        const { total } = response.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listStore = response?.data?.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  remove(data: any) {
    const index = this.listStoreId.findIndex((id: string) => id === data._id);
    if (index >= 0) {
      this.listStoreId.splice(index, 1);
      // this.listStoreSelected.splice(index, 1);
    }
  }

  @Watch("tab")
  changedTab(val: number) {
    if (val === 8) {
      this.onGetListStore();
      this.onGetListDiscount();
      this.onGetListUpsale();
    }
  }

  @Watch("listStoreId")
  changedListStoreId(val: any) {
    this.listStoreSelected = [];
    for (let id of val) {
      const findIndex = this.listStore.findIndex((item: any) => item.id === id);
      if (findIndex >= 0)
        this.listStoreSelected.push(this.listStore[findIndex]);
    }
    this.$store.commit("sellerStore/setListStoreId", cloneDeep(val));
  }

  @Watch("sellerDiscountId")
  changedSellerDiscountId(val: string) {
    this.$store.commit("sellerStore/setSellerDiscountId", val);
  }

  @Watch("status")
  changedStatus(val: boolean) {
    this.$store.commit("sellerStore/setStatusUpsale", val);
  }

  get storeId() {
    return this.$store.state.sellerStore.storeId;
  }
}
</script>
